program alp;
uses crt;
const
 nn=500;zz=4;ni=100;
var
 length,stiff,circum,fric,quake,point,quakep:real;
 dz,tz,sz,cp,fa,fp,wp:real;
 step,n,steps,nerr,mp,mq,plast,it:integer;
 z,w,f,d,s,t,wm,ea,ss,ta,tb:array[0..nn] of real;
 qp,qn:array[0..nn] of real;np,nq:array[0..nn] of integer;
 p:array[0..nn,1..zz] of real;pt:array[0..nn,1..zz] of integer;
procedure title;
 begin
  clrscr;gotoxy(38,1);textbackground(7);textcolor(0);write(' ALP ');
  textbackground(0);textcolor(7);writeln;writeln;
 end;
procedure next;
 var
  a:char;
 begin
  gotoxy(25,25);textbackground(7);textcolor(0);
  write(' Touch any key to continue ');write(chr(8));
  a:=readkey;textbackground(0);textcolor(7)
 end;
procedure input;
 var
  i:integer;
 begin
  title;
  write('This is a program for the analysis of an axially loaded');
  writeln(' pile.');writeln;
  write('Length of the pile (m) ......... ');readln(length);
  write('Axial stiffness EA (kN) ........ ');readln(stiff);
  write('Circumference (m) .............. ');readln(circum);
  write('Maximum friction (kN/m2) ....... ');readln(fric);
  write('Quake (m) ...................... ');readln(quake);
  write('Point resistance (kN) .......... ');readln(point);
  write('Quake of the point (m) ......... ');readln(quakep);
  write('Number of elements (max. ',nn,') .. ');readln(n);
  write('Number of loading steps ........ ');readln(steps);
  if n<10 then n:=10;if n>nn then n:=nn;
  dz:=length/n;tz:=dz*circum*fric;
  sz:=tz/quake;cp:=point/quakep;z[0]:=0;
  for i:=1 to n do
   begin
    d[i]:=dz;ea[i]:=stiff;ss[i]:=sz;ta[i]:=tz;tb[i]:=tz;
    qp[i]:=quake;qn[i]:=quake;z[i]:=z[i-1]+dz;
    wm[i]:=0;np[i]:=0;mp:=0;wp:=0;
   end;
 end;
procedure zeros;
 var
  i:integer;
 begin
  mp:=0;for i:=1 to n do np[i]:=0;
 end;
procedure initial;
 var
  i:integer;
 begin
  cp:=point/quakep;fp:=-cp*wp;
  if mp=1 then begin cp:=0;fp:=point;end;
  if mp=-1 then begin cp:=0;fp:=0;end;
  for i:=1 to n do
   begin
    s[i]:=ss[i];t[i]:=-ss[i]*wm[i];
    if np[i]=1 then begin s[i]:=0;t[i]:=ta[i];end;
    if np[i]=-1 then begin s[i]:=0;t[i]:=-tb[i];end;
   end;
 end;
procedure matrix;
 var
  i,j:integer;a1,a2,b1,b2,c1:real;
 begin
  for i:=0 to n do for j:=1 to zz do
   begin
    pt[i,j]:=0;p[i,j]:=0;
   end;
  for i:=1 to n-1 do
   begin
    pt[i,1]:=i;pt[i,2]:=i-1;pt[i,3]:=i+1;pt[i,zz]:=3;
   end;
  pt[0,1]:=0;pt[0,2]:=1;pt[0,zz]:=2;
  pt[n,1]:=n;pt[n,2]:=n-1;pt[n,zz]:=2;
  for i:=1 to n-1 do
   begin
    a1:=2*ea[i]/d[i];a2:=2*ea[i+1]/d[i+1];b1:=s[i]/2;b2:=s[i+1]/2;
    p[i,1]:=a1+a2+b1+b2;p[i,2]:=-a1+b1;p[i,3]:=-a2+b2;
    p[i,zz]:=-t[i]-t[i+1];
   end;
  a1:=2*ea[1]/d[1];b1:=s[1]/2;
  p[0,1]:=a1+b1;p[0,2]:=-a1+b1;p[0,zz]:=2*fa-t[1];
  a1:=2*ea[n]/d[n];b1:=s[n]/2;c1:=2*cp;
  p[n,1]:=a1+b1+c1;p[n,2]:=-a1+b1;p[n,zz]:=-2*fp-t[n];
 end;
procedure solve;
 var
  i,j,k,l,kc,jj,jk,jl,ii,ij,ik:integer;c:real;
 begin
  for i:=0 to n do
   begin
    kc:=pt[i,zz];if kc>1 then
     begin
      for j:=2 to kc do
       begin
        if p[i,1]=0.0 then
         begin
          writeln('Error : no equilibrium possible');halt;
         end;
        c:=p[i,j]/p[i,1];jj:=pt[i,j];
        p[jj,zz]:=p[jj,zz]-c*p[i,zz];l:=pt[jj,zz];
        for jl:=2 to l do begin if pt[jj,jl]=i then jk:=jl;end;
        pt[jj,jk]:=pt[jj,l];pt[jj,l]:=0;
        p[jj,jk]:=p[jj,l];p[jj,l]:=0;l:=l-1;pt[jj,zz]:=l;
        for ii:=2 to kc do
         begin
          ij:=0;for ik:=1 to l do
           begin
            if pt[jj,ik]=pt[i,ii] then ij:=ik;
           end;
          if ij=0 then
           begin
            l:=l+1;ij:=l;pt[jj,zz]:=l;pt[jj,ij]:=pt[i,ii];
           end;
          p[jj,ij]:=p[jj,ij]-c*p[i,ii];
         end;
       end;
     end;
    if p[i,1]=0.0 then
     begin
      writeln('Error : no equilibrium possible');halt;
     end;
    c:=1/p[i,1];for j:=1 to kc do p[i,j]:=c*p[i,j];
    p[i,zz]:=c*p[i,zz];
   end;
  for i:=0 to n do
   begin
    j:=n-i;l:=pt[j,zz];if l>1 then
     begin
      for k:=2 to l do
       begin
        jj:=pt[j,k];p[j,zz]:=p[j,zz]-p[j,k]*p[jj,zz];
       end;
     end;
   end;
  f[0]:=-fa;for i:=0 to n do w[i]:=p[i,zz];
  for i:=1 to n do f[i]:=2*ea[i]*(w[i]-w[i-1])/d[i]-f[i-1];
 end;
procedure checksprings;
 var
  i:integer;aa,eps:real;
 begin
  nerr:=0;plast:=0;eps:=0.000001;
  for i:=1 to n do
   begin
    nq[i]:=0;aa:=(w[i]+w[i-1])/2-wm[i];
    if aa>qp[i]+eps then nq[i]:=1;
    if aa<-qn[i]-eps then nq[i]:=-1;
   end;
  for i:=1 to n do
   begin
    if nq[i]<>np[i] then begin np[i]:=nq[i];nerr:=nerr+1;end;
    if nq[i]<>0 then plast:=plast+1;
   end;
  aa:=w[n]-wp;mq:=0;
  if aa>quakep+eps then mq:=1;if aa<-eps then mq:=-1;
  if mq<>mp then begin mp:=mq;nerr:=nerr+1;end;
  if mq<>0 then plast:=plast+1;
 end;
procedure update;
 var
  i:integer;aa:real;
 begin
  for i:=1 to n do
   begin
    aa:=(w[i]+w[i-1])/2-wm[i];
    if aa>qp[i] then wm[i]:=(w[i]+w[i-1])/2-qp[i];
    if aa<-qn[i] then wm[i]:=(w[i]+w[i-1])/2+qn[i];
   end;
  aa:=w[n]-wp;mq:=0;
  if aa>quakep then wp:=w[n]-quakep;if aa<0 then wp:=w[n];
 end;
begin
 input;
 for step:=1 to steps do
  begin
   title;it:=0;writeln('Loading step ',step);writeln;
   write('Force at the top (kN) .............. ');readln(fa);writeln;
   zeros;
   repeat
    initial;matrix;solve;checksprings;
    if plast=n then begin writeln('Pile failed');nerr:=0;end;
    it:=it+1;if it=ni then
     begin
      writeln('Warning : no convergence ');writeln;nerr:=0;
     end;
   until nerr=0;
   if plast<n then
    begin
     writeln('Displacement at the top (m) ........ ',w[0]:8:6);
     writeln;
     writeln('Number of plastic springs .......... ',plast);
     next;update;
    end
   else step:=steps;
  end;
 title;
end.
