program anisel;
uses crt;
const
 nn=100;mm=140;zz=20;
var
 data:text;n,m:integer;
 x,y,ux,uy,fx,fy:array[1..nn] of real;
 tx,ty:array[1..nn] of integer;np:array[1..mm,1..3] of integer;
 e11,e12,e13,e21,e22,e23,e31,e32,e33:array[1..mm] of real;
 pt:array[1..nn,1..zz] of integer;
 aa:array[1..nn,1..zz,1..2,1..2] of real;
procedure title;
 begin
  clrscr;gotoxy(37,1);textbackground(7);textcolor(0);write(' ANISEL ');
  textbackground(0);textcolor(7);writeln;
 end;
procedure next;
 var
  a:char;
 begin
  gotoxy(25,25);textbackground(7);textcolor(0);
  write(' Touch any key to continue ');write(chr(8));
  a:=readkey;textbackground(0);textcolor(7)
 end;
procedure input;
 var
  i,j:integer;name:string;
 begin
  title;writeln;
  writeln('This is a program for the analysis of two-dimensional');
  writeln('anisotropic elasticity problems by the finite element method.');
  writeln;
  write('Name of input datafile ............ ');readln(name);
  assign(data,name);reset(data);readln(data,n,m);
  for i:=1 to n do
   begin
    readln(data,x[i],y[i],tx[i],ty[i],fx[i],fy[i]);
    ux[i]:=fx[i];uy[i]:=fy[i];
   end;
  for j:=1 to m do
    readln(data,np[j,1],np[j,2],np[j,3],
    e11[j],e12[j],e13[j],e21[j],e22[j],e23[j],e31[j],e32[j],e33[j]);
  close(data);
 end;
procedure pointer;
 var
  i,j,k,kb,kk,l,ll,ia,ii:integer;
 begin
  writeln;writeln('Generation of pointer matrix');writeln;
  for i:=1 to n do
   begin
    pt[i,1]:=i;for j:=2 to zz-1 do pt[i,j]:=0;pt[i,zz]:=1;
   end;
  for j:=1 to m do
   begin
    for k:=1 to 3 do
     begin
      kk:=np[j,k];
      for l:=1 to 3 do
       begin
        ll:=np[j,l];ia:=0;
        for ii:=1 to pt[kk,zz] do if pt[kk,ii]=ll then ia:=1;
        if ia=0 then
         begin
          kb:=pt[kk,zz]+1;
          if kb=zz then
           begin
            writeln('Too many connections');halt;
           end;
          pt[kk,zz]:=kb;pt[kk,kb]:=ll;
         end;
       end;
     end;
   end;
 end;
procedure matrix;
 var
  i,j,k,l,ii,jj,kk,ll:integer;
  a1,ap,bb,bc,cb,cc,dd:real;
  xj,yj,b,c:array[1..3] of real;
  a:array[1..3,1..3,1..2,1..2] of real;
 begin
  writeln('Generation of matrix');writeln;
  for i:=1 to n do for j:=1 to zz do
  for k:=1 to 2 do for l:=1 to 2 do aa[i,j,k,l]:=0;
  for j:=1 to m do
   begin
    for i:=1 to 3 do
     begin
      k:=np[j,i];xj[i]:=x[k];yj[i]:=y[k];
     end;
    b[1]:=yj[2]-yj[3];b[2]:=yj[3]-yj[1];b[3]:=yj[1]-yj[2];
    c[1]:=xj[3]-xj[2];c[2]:=xj[1]-xj[3];c[3]:=xj[2]-xj[1];
    dd:=abs(xj[1]*b[1]+xj[2]*b[2]+xj[3]*b[3]);
    if (dd>0.0) then
     begin
      ap:=1/(2*dd);
      for k:=1 to 3 do for l:=1 to 3 do
       begin
        bb:=b[k]*b[l];bc:=b[k]*c[l];
        cb:=c[k]*b[l];cc:=c[k]*c[l];
        a[k,l,1,1]:=ap*(e11[j]*bb+e13[j]*bc+e31[j]*cb+e33[j]*cc);
        a[k,l,1,2]:=ap*(e12[j]*bc+e13[j]*bb+e32[j]*cc+e33[j]*cb);
        a[k,l,2,1]:=ap*(e31[j]*bb+e33[j]*bc+e21[j]*cb+e23[j]*cc);
        a[k,l,2,2]:=ap*(e32[j]*bc+e33[j]*bb+e22[j]*cc+e23[j]*cb);
       end;
      for i:=1 to 3 do
       begin
        jj:=np[j,i];ii:=pt[jj,zz];
        for k:=1 to ii do for l:=1 to 3 do
        if np[j,l]=pt[jj,k] then
        for kk:=1 to 2 do for ll:=1 to 2 do
        aa[jj,k,kk,ll]:=aa[jj,k,kk,ll]+a[i,l,kk,ll];
       end;
     end;
   end;
  for i:=1 to n do
   begin
    if (tx[i]<1) then aa[i,zz,1,1]:=aa[i,zz,1,1]+fx[i]
    else
     begin
      for j:=1 to zz do for l:=1 to 2 do aa[i,j,1,l]:=0;
      aa[i,1,1,1]:=1;aa[i,zz,1,1]:=ux[i];
     end;
    if (ty[i]<1) then aa[i,zz,2,2]:=aa[i,zz,2,2]+fy[i]
    else
     begin
      for j:=1 to zz do for l:=1 to 2 do aa[i,j,2,l]:=0;
      aa[i,1,2,2]:=1;aa[i,zz,2,2]:=uy[i];
     end;
   end;
 end;
procedure wavefront;
 var
  cc:real;
  i,ia,ii,ij,ik,j,jj,jk,jv,k,kc,kv,kk,l,lv:integer;
  f:array[1..3,1..3] of real;
 begin
  writeln('Solution of equations');writeln('   Elimination');
  for i:=1 to n do
   begin
    kc:=pt[i,zz];
    for kv:=1 to 2 do
     begin
      cc:=1/aa[i,1,kv,kv];
      for ii:=1 to kc do for lv:=1 to 2 do
       aa[i,ii,kv,lv]:=cc*aa[i,ii,kv,lv];
      aa[i,zz,kv,kv]:=cc*aa[i,zz,kv,kv];
      for lv:=1 to 2 do if lv<>kv then
       begin
        cc:=aa[i,1,lv,kv];
        for ii:=1 to kc do for ij:=1 to 2 do
        aa[i,ii,lv,ij]:=aa[i,ii,lv,ij]-cc*aa[i,ii,kv,ij];
        aa[i,zz,lv,lv]:=aa[i,zz,lv,lv]-cc*aa[i,zz,kv,kv];
       end;
     end;
    if kc>1 then
     begin
      for j:=2 to kc do
       begin
        jj:=pt[i,j];l:=pt[jj,zz];jk:=1;ik:=0;
        while ik=0 do
         begin
          jk:=jk+1;if pt[jj,jk]=i then ik:=1;
         end;
        for kv:=1 to 2 do for lv:=1 to 2 do
        f[kv,lv]:=aa[jj,jk,kv,lv];
        pt[jj,jk]:=pt[jj,l];pt[jj,l]:=0;
        for kv:=1 to 2 do for lv:=1 to 2 do
         begin
          aa[jj,jk,kv,lv]:=aa[jj,l,kv,lv];
          aa[jj,l,kv,lv]:=0;
          aa[jj,zz,lv,lv]:=aa[jj,zz,lv,lv]-f[lv,kv]*aa[i,zz,kv,kv];
         end;
        l:=l-1;
        pt[jj,zz]:=l;
        for ii:=2 to kc do
         begin
          ij:=-1;
          for ik:=1 to l do if pt[jj,ik]=pt[i,ii] then ij:=ik;
          if ij=-1 then
           begin
            l:=l+1;
            if l=zz then
             begin
              writeln;writeln('Too many connections');halt;
             end;
            ij:=l;pt[jj,zz]:=l;pt[jj,ij]:=pt[i,ii];
           end;
          for kv:=1 to 2 do for lv:=1 to 2 do for jv:=1 to 2 do
          aa[jj,ij,kv,lv]:=aa[jj,ij,kv,lv]-f[kv,jv]*aa[i,ii,jv,lv];
         end;
       end;
     end;
   end;
  writeln('   Back substitution');writeln;
  for i:=1 to n do
   begin
    j:=n-i+1;l:=pt[j,zz];
    if l>1 then
     begin
      for k:=2 to l do
       begin
        jj:=pt[j,k];
        for kv:=1 to 2 do for lv:=1 to 2 do
        aa[j,zz,kv,kv]:=aa[j,zz,kv,kv]-aa[j,k,kv,lv]*aa[jj,zz,lv,lv];
       end;
     end;
   end;
  writeln;
  for i:=1 to n do
   begin
    ux[i]:=aa[i,zz,1,1];uy[i]:=aa[i,zz,2,2];
   end;
 end;
procedure output;
 var
  i,j,k,l,i1,i2,ii:integer;
  b,c:array[1..3] of real;
  d,aa,bb,bc,cb,cc,sxx,syy,sxy:real;
 begin
  l:=0;i1:=1;while l=0 do
   begin
    title;writeln('   i     x           y           ux          uy');
    writeln;i2:=i1+19;if i2>n then i2:=n;
    for i:=i1 to i2 do
     begin
      writeln(i:4,x[i]:12:6,y[i]:12:6,ux[i]:12:6,uy[i]:12:6);
     end;
    next;i1:=i1+20;if i1>n then l:=1;
   end;
  l:=0;i1:=1;while l=0 do
   begin
    title;writeln('   i       Nodes       sxx         syy         sxy');
    writeln;i2:=i1+19;if i2>m then i2:=m;
    for ii:=i1 to i2 do
     begin
      i:=np[ii,1];j:=np[ii,2];k:=np[ii,3];
      b[1]:=y[j]-y[k];b[2]:=y[k]-y[i];b[3]:=y[i]-y[j];
      c[1]:=x[k]-x[j];c[2]:=x[i]-x[k];c[3]:=x[j]-x[i];
      d:=x[i]*b[1]+x[j]*b[2]+x[k]*b[3];
      bb:=(b[1]*ux[i]+b[2]*ux[j]+b[3]*ux[k])/d;
      cc:=(c[1]*uy[i]+c[2]*uy[j]+c[3]*uy[k])/d;
      bc:=(b[1]*uy[i]+b[2]*uy[j]+b[3]*uy[k])/d;
      cb:=(c[1]*ux[i]+c[2]*ux[j]+c[3]*ux[k])/d;
      sxx:=e11[ii]*bb+e12[ii]*cc+e13[ii]*(bc+cb);
      syy:=e21[ii]*bb+e22[ii]*cc+e23[ii]*(bc+cb);
      sxy:=e31[ii]*bb+e32[ii]*cc+e33[ii]*(bc+cb);
      writeln(ii:4,i:6,j:4,k:4,sxx:12:6,syy:12:6,sxy:12:6);
     end;
    next;i1:=i1+20;if i1>m then l:=1;
   end;
  clrscr;
 end;
begin
 title;
 input;
 pointer;
 matrix;
 wavefront;
 output;
end.
