program consol2d;
uses crt;
const
 nn=60;mm=40;zz=16;ss=100;
var
 data:text;i,j,jz,k,l,m,n,df,ii,is,nsteps:integer;
 dt,ep,ea,eb,eps,fb,fc,tz:real;
 x,y,p,wa,ux,uy,fx,fy,uxa,uya:array[1..nn] of real;
 t:array[1..nn] of integer;np:array[1..mm,1..4] of integer;
 p1,p2,p3,p4:array[1..mm] of real;ks:array[1..4,1..3] of integer;
 pt,pta:array[1..nn,1..zz] of integer;
 aa:array[1..nn,1..zz,1..3,1..3] of real;
 tt,rf:array[0..ss] of real;
procedure title;
 begin
  clrscr;gotoxy(35,1);textbackground(7);textcolor(0);write(' CONSOL2D ');
  textbackground(0);textcolor(7);writeln;
 end;
procedure next;
 var
  a:char;
 begin
  gotoxy(25,25);textbackground(7);textcolor(0);
  write(' Touch any key to continue ');write(chr(8));
  a:=readkey;textbackground(0);textcolor(7)
 end;
procedure input;
 var
  i,j,k:integer;c2,tc:real;name:string;
 begin
  title;writeln;
  writeln('This is a program for the analysis of two-dimensional');
  writeln('consolidation by the finite element method.');writeln;
  write('Name of input datafile ............ ');readln(name);
  assign(data,name);reset(data);readln(data,n,m,nsteps);
  for i:=1 to n do
   begin
    readln(data,x[i],y[i],p[i],ux[i],uy[i],fx[i],fy[i],t[i]);
    p[i]:=-p[i];
   end;
  for j:=1 to m do
    readln(data,np[j,1],np[j,2],np[j,3],np[j,4],p1[j],p2[j],p3[j],p4[j]);
  for k:=1 to nsteps do readln(data,tt[k],rf[k]);
  close(data);
 end;
procedure initialize;
 begin
  jz:=1;tz:=0;fb:=0;eps:=0.000001;ep:=0.25;ea:=1-ep;eb:=1/ea;
  for i:=1 to 4 do for j:=1 to 3 do
   begin
    k:=i+j-1;if k>4 then k:=k-4;ks[i,j]:=k
   end;
  for i:=1 to n do
   begin
    uxa[i]:=ux[i];uya[i]:=uy[i];wa[i]:=p[i]
   end;
 end;
procedure pointer;
 var
  i,j,k,kb,kk,ll,ia,ii:integer;
 begin
  writeln;writeln('Generation of pointer matrix');writeln;
  for i:=1 to n do
   begin
    pt[i,1]:=i;for j:=2 to zz-1 do pt[i,j]:=0;pt[i,zz]:=1;
   end;
  for j:=1 to m do
   begin
    for k:=1 to 4 do
     begin
      kk:=np[j,k];
      for l:=1 to 4 do
       begin
        ll:=np[j,l];ia:=0;
        for ii:=1 to pt[kk,zz] do if pt[kk,ii]=ll then ia:=1;
        if ia=0 then
         begin
          kb:=pt[kk,zz]+1;
          if kb=zz then
           begin
            writeln('Too many connections');halt;
           end;
          pt[kk,zz]:=kb;pt[kk,kb]:=ll;
         end;
       end;
     end;
   end;
  for i:=1 to n do for j:=1 to zz do pta[i,j]:=pt[i,j];
 end;
procedure matrix;
 var
  i,j,k,l,iz,kw,ii,jj,kk,ll:integer;
  a1,ap,ae,af,bb,bc,bd,cb,cc,cd,db,dc,dd,dl,gg,gk,pl,xx,xy,yy:real;
  xj,yj,b,c,d:array[1..3] of real;
  f:array[1..3,1..3] of real;
  a:array[1..3,1..3,1..3,1..3] of real;
 begin
  writeln('Generation of matrix');writeln;
  for i:=1 to n do for j:=1 to zz do
   begin
    pt[i,j]:=pta[i,j];
    for k:=1 to 3 do for l:=1 to 3 do aa[i,j,k,l]:=0
   end;
  for j:=1 to m do
   begin
    for iz:=jz to 2 do
     begin
      for kw:=1 to 4 do
       begin
        xx:=0;yy:=0;
        for i:=1 to 3 do
         begin
          k:=np[j,ks[kw,i]];xj[i]:=x[k];yj[i]:=y[k];
          xx:=xx+xj[i];yy:=yy+yj[i]
         end;
        xx:=xx/3;yy:=yy/3;
        for i:=1 to 3 do begin xj[i]:=xj[i]-xx;yj[i]:=yj[i]-yy;end;
        b[1]:=yj[2]-yj[3];b[2]:=yj[3]-yj[1];b[3]:=yj[1]-yj[2];
        c[1]:=xj[3]-xj[2];c[2]:=xj[1]-xj[3];c[3]:=xj[2]-xj[1];
        d[1]:=xj[2]*yj[3]-xj[3]*yj[2];d[2]:=xj[3]*yj[1]-xj[1]*yj[3];
        d[3]:=xj[1]*yj[2]-xj[2]*yj[1];dl:=d[1]+d[2]+d[3];
        if dl<0 then
         begin
          k:=np[j,ks[kw,2]];np[j,ks[kw,2]]:=np[j,ks[kw,3]];
          np[j,ks[kw,3]]:=k
         end;
        dd:=abs(dl);
        if (dd>eps) and (iz=2) then
         begin
          ap:=1/(4*dd);af:=ap*dt*p3[j];ae:=ap*p4[j];
          xx:=(xj[1]*xj[1]+xj[2]*xj[2]+xj[3]*xj[3])/12;
          yy:=(yj[1]*yj[1]+yj[2]*yj[2]+yj[3]*yj[3])/12;
          xy:=(xj[1]*yj[1]+xj[2]*yj[2]+xj[3]*yj[3])/12;
          for k:=1 to 3 do for l:=1 to 3 do
           begin
            bb:=b[k]*b[l];bc:=b[k]*c[l];bd:=b[k]*d[l];
            cb:=c[k]*b[l];cc:=c[k]*c[l];cd:=c[k]*d[l];
            db:=d[k]*b[l];dc:=d[k]*c[l];dd:=d[k]*d[l];
            gk:=p1[j]-2*p2[j]/3;gg:=p2[j];
            a[k,l,1,1]:=ap*((gk+2*gg)*bb+gg*cc);
            a[k,l,1,2]:=ap*(gk*bc+gg*cb);
            a[k,l,1,3]:=ap*bd;
            a[l,k,2,1]:=a[k,l,1,2];
            a[k,l,2,2]:=ap*((gk+2*gg)*cc+gg*bb);
            a[k,l,2,3]:=ap*cd;
            a[l,k,3,1]:=a[k,l,1,3];
            a[l,k,3,2]:=a[k,l,2,3];
            f[k,l]:=-af*(bb+cc);
            a[k,l,3,3]:=ea*f[k,l]-ae*(bb*xx+(bc+cb)*xy+cc*yy+dd)
           end;
          for i:=1 to 3 do
           begin
            jj:=np[j,ks[kw,i]];ii:=pt[jj,zz];
            for k:=1 to ii do for l:=1 to 3 do
             if np[j,ks[kw,l]]=pt[jj,k] then
              for kk:=1 to 3 do for ll:=1 to 3 do
               aa[jj,k,kk,ll]:=aa[jj,k,kk,ll]+a[i,l,kk,ll];
           end;
          for k:=1 to 3 do
           begin
            kk:=np[j,ks[kw,k]];
            for l:=1 to 3 do
             begin
              ll:=np[j,ks[kw,l]];
              aa[kk,zz,3,3]:=aa[kk,zz,3,3]-f[k,l]*wa[ll]
             end;
           end;
         end;
       end;
     end;
   end;
  jz:=2;
  for i:=1 to n do
   begin
    kk:=abs(t[i]);
    if (kk=1) or (kk=2) then aa[i,zz,2,2]:=aa[i,zz,2,2]+fy[i]*fc;
    if (kk=1) or (kk=3) then aa[i,zz,1,1]:=aa[i,zz,1,1]+fx[i]*fc;
    if (kk=3) or (kk=4) then
     begin
      k:=2;a1:=uya[i]*fc;
      for j:=1 to zz do for l:=1 to 3 do aa[i,j,k,l]:=0;
      aa[i,1,k,k]:=1;aa[i,zz,k,k]:=a1;
     end;
    if (kk=2) or (kk=4) then
     begin
      k:=1;a1:=uxa[i]*fc;
      for j:=1 to zz do for l:=1 to 3 do aa[i,j,k,l]:=0;
      aa[i,1,k,k]:=1;aa[i,zz,k,k]:=a1;
     end;
    if t[i]>0 then
     begin
      k:=3;a1:=wa[i];
      for j:=1 to zz do for l:=1 to 3 do aa[i,j,k,l]:=0;
      aa[i,1,k,k]:=1;aa[i,zz,k,k]:=a1;
     end;
   end;
 end;
procedure wavefront;
 var
  cc:real;
  i,ia,ij,ik,j,jj,jk,jv,kc,kv,kk,l,lv:integer;
  f:array[1..3,1..3] of real;
 begin
  writeln('Solution of equations');writeln('   Elimination');
  for i:=1 to n do
   begin
    kc:=pt[i,zz];
    for kv:=1 to 3 do
     begin
      cc:=1/aa[i,1,kv,kv];
      for ii:=1 to kc do for lv:=1 to 3 do
       aa[i,ii,kv,lv]:=cc*aa[i,ii,kv,lv];
      aa[i,zz,kv,kv]:=cc*aa[i,zz,kv,kv];
      for lv:=1 to 3 do if lv<>kv then
       begin
        cc:=aa[i,1,lv,kv];
        for ii:=1 to kc do for ij:=1 to 3 do
         aa[i,ii,lv,ij]:=aa[i,ii,lv,ij]-cc*aa[i,ii,kv,ij];
        aa[i,zz,lv,lv]:=aa[i,zz,lv,lv]-cc*aa[i,zz,kv,kv];
       end;
     end;
    if kc>1 then
     begin
      for j:=2 to kc do
       begin
        jj:=pt[i,j];l:=pt[jj,zz];jk:=1;ik:=0;
        while ik=0 do
         begin
          jk:=jk+1;if pt[jj,jk]=i then ik:=1;
         end;
        for kv:=1 to 3 do for lv:=1 to 3 do
         f[kv,lv]:=aa[jj,jk,kv,lv];
        pt[jj,jk]:=pt[jj,l];pt[jj,l]:=0;
        for kv:=1 to 3 do for lv:=1 to 3 do
         begin
          aa[jj,jk,kv,lv]:=aa[jj,l,kv,lv];
          aa[jj,l,kv,lv]:=0;
          aa[jj,zz,lv,lv]:=aa[jj,zz,lv,lv]-f[lv,kv]*aa[i,zz,kv,kv];
         end;
        l:=l-1;
        pt[jj,zz]:=l;
        for ii:=2 to kc do
         begin
          ij:=-1;
          for ik:=1 to l do if pt[jj,ik]=pt[i,ii] then ij:=ik;
          if ij=-1 then
           begin
            l:=l+1;
            if l=zz then
             begin
              writeln;writeln('Too many connections');halt;
             end;
            ij:=l;pt[jj,zz]:=l;pt[jj,ij]:=pt[i,ii];
           end;
          for kv:=1 to 3 do for lv:=1 to 3 do for jv:=1 to 3 do
           aa[jj,ij,kv,lv]:=aa[jj,ij,kv,lv]-f[kv,jv]*aa[i,ii,jv,lv];
         end;
       end;
     end;
   end;
  writeln('   Back substitution');writeln;
  for i:=1 to n do
   begin
    j:=n-i+1;l:=pt[j,zz];
    if l>1 then
     begin
      for k:=2 to l do
       begin
        jj:=pt[j,k];
        for kv:=1 to 3 do for lv:=1 to 3 do
         aa[j,zz,kv,kv]:=aa[j,zz,kv,kv]-aa[j,k,kv,lv]*aa[jj,zz,lv,lv];
       end;
     end;
   end;
  writeln;
 end;
procedure output;
 begin
  l:=0;j:=1;while l=0 do
   begin
    title;writeln('Time : ',tz:12:3);
    writeln('   i        x           y        ux          uy          p');
    writeln;k:=j+19;if k>n then k:=n;
    for i:=j to k do
     begin
      writeln(i:4,x[i]:12:3,y[i]:12:3,ux[i]:12:6,uy[i]:12:6,-p[i]:12:6);
     end;
    next;j:=j+20;if j>n then l:=1;
   end;
 end;
begin
 title;input;initialize;pointer;
 for is:=1 to nsteps do
  begin
   title;writeln('Time step ',is);writeln;
   dt:=tt[is]-tz;tz:=tt[is];fc:=rf[is]-fb;fb:=rf[is];
   matrix;wavefront;
   for i:=1 to n do
    begin
     ux[i]:=aa[i,zz,1,1];uy[i]:=aa[i,zz,2,2];p[i]:=aa[i,zz,3,3];
     uxa[i]:=uxa[i]+ux[i];uya[i]:=uya[i]+uy[i];wa[i]:=wa[i]+p[i];
     ux[i]:=uxa[i];uy[i]:=uya[i];p[i]:=wa[i];
    end;
   output;
  end;
 clrscr;
end.
