program elasto;
uses crt;
const
 nn=150;mm=250;zz=26;
var
 x,y,fx,fy,ux,uy:array[1..nn] of real;xt,yt:array[1..nn] of integer;
 cm,sm,bx,by:array[1..mm] of real;s:array[1..mm,1..3] of integer;
 p:array[1..2*nn,1..zz] of real;r:array[1..2*nn] of real;
 n,m,l,w:integer;data:text;
procedure title;
 begin
  clrscr;gotoxy(36,1);textbackground(7);textcolor(0);write(' ELASTO ');
  textbackground(0);textcolor(7);writeln;writeln;
 end;
procedure next;
 var
  a:char;
 begin
  gotoxy(25,25);textbackground(7);textcolor(0);
  write(' Touch any key to continue ');write(chr(8));
  a:=readkey;textbackground(0);textcolor(7)
 end;
procedure input;
 var
  i,j,k:integer;c2,tc:real;name:string;
 begin
  title;
  writeln('This is a program for the analysis of plane strain');
  writeln('elasticity by the finite element method.');writeln;
  write('Name of input datafile ............ ');readln(name);
  assign(data,name);reset(data);readln(data,n,m);l:=2*n;
  for i:=1 to n do readln(data,x[i],y[i],xt[i],yt[i],fx[i],fy[i]);
  for j:=1 to m do
    readln(data,s[j,1],s[j,2],s[j,3],cm[j],sm[j],bx[j],by[j]);
  close(data);title;
  for i:=1 to n do begin ux[i]:=fx[i];uy[i]:=fy[i];end;
  w:=0;for j:=1 to m do
   begin
    k:=abs(s[j,1]-s[j,2]);if k>w then w:=k;
    k:=abs(s[j,2]-s[j,3]);if k>w then w:=k;
    k:=abs(s[j,3]-s[j,1]);if k>w then w:=k;
   end;
  w:=2*(w+1);
  if (w>zz) then
   begin
    writeln('Band width too large.');writeln;halt;
   end;
 end;
procedure matrix;
 var
  i,j,k,ia,ib,iu,iv,ka,ku,kv,kk,kl,km:integer;
  d,aa,dd,ee,a1,a2:real;
  xx,yy,b,c:array[1..3] of real;
  pa,qa,sa:array[1..3,1..3] of real;
 begin
  for i:=1 to l do
   begin
    r[i]:=0;for j:=1 to w do p[i,j]:=0;
   end;
  writeln('Generation of matrix');writeln;
  for j:=1 to m do
   begin
    for i:=1 to 3 do
     begin
      k:=s[j,i];xx[i]:=x[k];yy[i]:=y[k];
     end;
    b[1]:=yy[2]-yy[3];b[2]:=yy[3]-yy[1];b[3]:=yy[1]-yy[2];
    c[1]:=xx[3]-xx[2];c[2]:=xx[1]-xx[3];c[3]:=xx[2]-xx[1];
    d:=abs(xx[1]*b[1]+xx[2]*b[2]+xx[3]*b[3]);
    dd:=sm[j]/(2*d);ee:=cm[j]/sm[j]-2/3;aa:=ee+2;
    for i:=1 to 3 do for k:=1 to 3 do
     begin
      pa[i,k]:=dd*(aa*b[i]*b[k]+c[i]*c[k]);
      qa[i,k]:=dd*(ee*b[i]*c[k]+c[i]*b[k]);
      sa[i,k]:=dd*(aa*c[i]*c[k]+b[i]*b[k]);
     end;
    for i:=1 to 3 do
     begin
      ia:=s[j,i];iu:=2*ia-1;
      for k:=1 to 3 do
       begin
        ka:=s[j,k];ku:=2*ka-iu;if ku>0 then
         begin
          kv:=ku+1;p[iu,ku]:=p[iu,ku]+pa[i,k];
          p[iu,kv]:=p[iu,kv]+qa[i,k];
         end;
       end;
     end;
    for i:=1 to 3 do
     begin
      ia:=s[j,i];iv:=2*ia;
      for k:=1 to 3 do
       begin
        ka:=s[j,k];ku:=2*ka-iv;kv:=ku+1;if kv>0 then
         begin
          p[iv,kv]:=p[iv,kv]+sa[i,k];
          if ku>0 then p[iv,ku]:=p[iv,ku]+qa[k,i];
         end;
       end;
     end;
    a1:=bx[j]*d/6;a2:=by[j]*d/6;
    for k:=1 to 3 do
     begin
      i:=s[j,k];ib:=2*i;ia:=ib-1;
      r[ia]:=r[ia]+a1;r[ib]:=r[ib]+a2;
     end;
   end;
  for i:=1 to n do
   begin
    k:=2*i-1;if xt[i]<1 then r[k]:=r[k]+fx[i] else
     begin
      r[k]:=ux[i];p[k,1]:=1;if k>1 then
       begin
        kk:=k-w+1;kl:=k-1;if kk<1 then kk:=1;
        for j:=kk to kl do
         begin
          km:=k-j+1;r[j]:=r[j]-p[j,km]*ux[i];p[j,km]:=0;
         end;
       end;
      kk:=k+1;kl:=k+w-1;if kl>l then kl:=l;
      for j:=kk to kl do
       begin
        km:=j-k+1;r[j]:=r[j]-p[k,km]*ux[i];
       end;
      for j:=2 to w do p[k,j]:=0;
     end;
    k:=2*i;if yt[i]<1 then r[k]:=r[k]+fy[i] else
     begin
      r[k]:=uy[i];p[k,1]:=1;if k>1 then
       begin
        kk:=k-w+1;kl:=k-1;if kk<1 then kk:=1;
        for j:=kk to kl do
         begin
          km:=k-j+1;r[j]:=r[j]-p[j,km]*uy[i];p[j,km]:=0;
         end;
       end;
      if k<l then
       begin
        kk:=k+1;kl:=k+w-1;if kl>l then kl:=l;
        for j:=kk to kl do
         begin
          km:=j-k+1;r[j]:=r[j]-p[k,km]*uy[i];
         end;
        for j:=2 to w do p[k,j]:=0;
       end;
     end;
   end;
 end;
procedure solve;
 var
  i,j,k,ll,lm,jj,mm,nc,iz,ii:integer;
  a1,a2,a3:real;
 begin
  writeln('Solution of equations');writeln('   Elimination');
  for i:=1 to l do
   begin
    ll:=w;lm:=l-i+1;if ll>lm then ll:=lm;
    for j:=1 to ll do
     begin
      a1:=p[i,j];p[i,j]:=1;jj:=j-1;mm:=w-jj;if mm>i then mm:=i;
      while mm>1 do
       begin
        k:=i-mm+1;a2:=p[k,mm];a3:=p[k,mm+jj];a1:=a1-p[k,1]*a2*a3;
        mm:=mm-1;
       end;
      p[i,j]:=a1/p[i,1];
     end;
   end;
  nc:=w-1;for i:=2 to l do
   begin
    a1:=r[i];k:=i-nc;if k<1 then k:=1;
    iz:=i-1;for j:=k to iz do a1:=a1-p[j,i-j+1]*r[j];
    r[i]:=a1;
   end;
  for i:=1 to l do r[i]:=r[i]/p[i,1];
  writeln('   Back substitution');
  for ii:=2 to l do
   begin
    i:=l-ii+1;a1:=r[i];iz:=i+nc;if iz>l then iz:=l;
    k:=i+1;for j:=k to iz do a1:=a1-p[i,j-i+1]*r[j];
    r[i]:=a1;
   end;
  for i:=1 to n do
   begin
    k:=2*i;j:=k-1;ux[i]:=r[j];uy[i]:=r[k];
   end;
 end;
procedure output;
 var
  i,j,k,l,i1,i2,ii:integer;
  b,c:array[1..3] of real;
  d,aa,u,v,w,sxx,syy,sxy:real;
 begin
  l:=0;i1:=1;while l=0 do
   begin
    title;writeln('   i     x           y           ux          uy');
    writeln;i2:=i1+19;if i2>n then i2:=n;
    for i:=i1 to i2 do
     begin
      writeln(i:4,x[i]:12:6,y[i]:12:6,ux[i]:12:6,uy[i]:12:6);
     end;
    next;i1:=i1+20;if i1>n then l:=1;
   end;
  l:=0;i1:=1;while l=0 do
   begin
    title;writeln('   i       Nodes       sxx         syy         sxy');
    writeln;i2:=i1+19;if i2>m then i2:=m;
    for ii:=i1 to i2 do
     begin
      i:=s[ii,1];j:=s[ii,2];k:=s[ii,3];
      b[1]:=y[j]-y[k];b[2]:=y[k]-y[i];b[3]:=y[i]-y[j];
      c[1]:=x[k]-x[j];c[2]:=x[i]-x[k];c[3]:=x[j]-x[i];
      d:=x[i]*b[1]+x[j]*b[2]+x[k]*b[3];
      d:=sm[ii]/d;aa:=cm[ii]/sm[ii]-2/3;
      u:=b[1]*ux[i]+b[2]*ux[j]+b[3]*ux[k];
      w:=c[1]*uy[i]+c[2]*uy[j]+c[3]*uy[k];
      v:=b[1]*uy[i]+b[2]*uy[j]+b[3]*uy[k];
      v:=v+c[1]*ux[i]+c[2]*ux[j]+c[3]*ux[k];
      sxx:=d*(aa*(u+w)+2*u);syy:=d*(aa*(u+w)+2*w);sxy:=d*v;
      writeln(ii:4,i:6,j:4,k:4,sxx:12:6,syy:12:6,sxy:12:6);
     end;
    next;i1:=i1+20;if i1>m then l:=1;
   end;
  clrscr;
 end;
begin
 input;
 matrix;
 solve;
 output;
end.
