program femflux;
uses crt,graph;
const
 nn=300;mm=500;zz=10;pp=50;
var
 maxx,maxy,graphdriver,graphmode,errorcode:integer;xasp,yasp:word;
 x,y,h,f,q,u,v,w:array[1..nn] of real;ip:array[1..nn] of integer;
 perm,por,inf,vx,vy:array[1..mm] of real;
 np:array[1..mm,1..3] of integer;
 p:array[1..nn,1..zz-1] of real;pt:array[1..nn,1..zz] of integer;
 xp,yp:array[1..pp] of real;sp,lp:array[1..pp] of integer;
 xj,yj,b,c:array[1..3] of real;
 n,m,mp:integer;ns:longint;step:real;data:text;
procedure title;
 begin
  clrscr;gotoxy(35,1);textbackground(7);textcolor(0);write(' FEMFLUX ');
  textbackground(0);textcolor(7);writeln;writeln;
 end;
procedure graphinitialize;
 begin
  graphdriver:=detect;initgraph(graphdriver,graphmode,'');
  errorcode:=graphresult;
  if (errorcode<>grok) then
   begin
    writeln('Error in graphics :',grapherrormsg(errorcode));
    writeln;writeln('Program interrupted.');halt(1);
   end;
  setcolor(7);setbkcolor(0);setlinestyle(0,0,1);
  setfillstyle(11,7);maxx:=getmaxx;maxy:=getmaxy;
  getaspectratio(xasp,yasp);closegraph;
 end;
procedure input;
 var
  i,j,k:integer;name:string;
 begin
  title;
  writeln('This is a program for the analysis of transport by');
  writeln('groundwater flow by the finite element method.');writeln;
  write('Name of input datafile ............ ');readln(name);
  assign(data,name);reset(data);readln(data,n,m,mp,ns,step);
  for i:=1 to n do readln(data,x[i],y[i],h[i],ip[i],f[i],q[i]);
  for j:=1 to m do
    readln(data,np[j,1],np[j,2],np[j,3],perm[j],por[j],inf[j]);
  for k:=1 to mp do
   begin
    readln(data,xp[k],yp[k]);sp[k]:=1;lp[k]:=1;
   end;
  close(data);title;
 end;
procedure pointer;
 var
  i,j,k,l,kk,ll,ia,ii,kb:integer;
 begin
  title;writeln('Generation of pointer matrix');writeln;
  for i:=1 to n do for j:=1 to zz do pt[i,j]:=0;
  for i:=1 to n do begin pt[i,1]:=i;pt[i,zz]:=1;end;
  for j:=1 to m do
   begin
    for k:=1 to 3 do
     begin
      kk:=np[j,k];for l:=1 to 3 do
       begin
        ll:=np[j,l];ia:=0;
        for ii:=1 to pt[kk,zz] do if pt[kk,ii]=ll then ia:=1;
        if ia=0 then
         begin
          kb:=pt[kk,zz]+1;if kb=zz then
           begin
            writeln('Pointer width too small.');writeln;halt;
           end;
          pt[kk,zz]:=kb;pt[kk,kb]:=ll;
         end;
       end;
     end;
   end;
 end;
procedure matrix;
 var
  i,j,k,l,kv,kw,ii,kk,ll:integer;hh,dd,dp:real;
 begin
  writeln('Generation of system matrix');writeln;
  for i:=1 to n do for j:=1 to zz-1 do p[i,j]:=0;
  for j:=1 to m do
   begin
    hh:=0;for i:=1 to 3 do
     begin
      k:=np[j,i];xj[i]:=x[k];yj[i]:=y[k];hh:=hh+h[k]/3;
     end;
    b[1]:=yj[2]-yj[3];b[2]:=yj[3]-yj[1];b[3]:=yj[1]-yj[2];
    c[1]:=xj[3]-xj[2];c[2]:=xj[1]-xj[3];c[3]:=xj[2]-xj[1];
    dd:=abs(b[1]*xj[1]+b[2]*xj[2]+b[3]*xj[3]);dp:=perm[j]*hh/(2*dd);
    for k:=1 to 3 do
     begin
      kk:=np[j,k];ii:=pt[kk,zz];
      for ll:=1 to ii do for l:=1 to 3 do if np[j,l]=pt[kk,ll] then
        p[kk,ll]:=p[kk,ll]+dp*(b[k]*b[l]+c[k]*c[l]);
      q[kk]:=q[kk]+dd*inf[j]/6;
     end;
   end;
 end;
procedure search(xx,yy:real;j:integer;var jj:integer);
 var
  i,k,kk,ll:integer;a1,a2,a3:real;
 begin
  jj:=0;for i:=1 to 3 do
   begin
    k:=np[j,i];xj[i]:=x[k];yj[i]:=y[k];
   end;
  b[1]:=yj[2]-yj[3];b[2]:=yj[3]-yj[1];b[3]:=yj[1]-yj[2];
  c[1]:=xj[3]-xj[2];c[2]:=xj[1]-xj[3];c[3]:=xj[2]-xj[1];
  a1:=(yy-yj[1])*c[3]+(xx-xj[1])*b[3];
  a2:=(yy-yj[2])*c[1]+(xx-xj[2])*b[1];
  a3:=(yy-yj[3])*c[2]+(xx-xj[3])*b[2];
  if ((a1*a2>=0) and (a2*a3>=0) and (a3*a1>=0)) then jj:=j;
 end;
procedure locate(xx,yy:real;j:integer;var jj:integer);
 var
  i,i1,i2,kk,ll:integer;
 begin
  jj:=0;kk:=0;ll:=0;while (ll=0) do
   begin
    i:=j+kk;if ((i<=m) and (i>=1)) then search(xx,yy,i,i1);
    if (i1>0) then jj:=i1;
    i:=j-kk;if ((i<=m) and (i>=1)) then search(xx,yy,i,i2);
    if (i2>0) then jj:=i2;if (jj>0) then ll:=1;
    kk:=kk+1;if (kk>=m) then ll:=1;
   end;
 end;
procedure velocities;
 var
  i,j,k:integer;d:real;
 begin
  for j:=1 to m do
   begin
    for i:=1 to 3 do
     begin
      k:=np[j,i];xj[i]:=x[k];yj[i]:=y[k];
     end;
    b[1]:=yj[2]-yj[3];b[2]:=yj[3]-yj[1];b[3]:=yj[1]-yj[2];
    c[1]:=xj[3]-xj[2];c[2]:=xj[1]-xj[3];c[3]:=xj[2]-xj[1];
    d:=b[1]*xj[1]+b[2]*xj[2]+b[3]*xj[3];
    vx[j]:=0;vy[j]:=0;d:=perm[j]/(d*por[j]);
    for i:=1 to 3 do
     begin
      k:=np[j,i];
      vx[j]:=vx[j]-d*b[i]*f[k];vy[j]:=vy[j]-d*c[i]*f[k];
     end;
   end;
 end;
procedure solve;
 var
  it,i,j,iw:integer;ee,uu,vw,ww,aa,bb:real;
 begin
  writeln('Solution of equations');writeln;
  ee:=0.000001;ee:=ee*ee;it:=1;
  for i:=1 to n do
   begin
    iw:=pt[i,zz];u[i]:=0;if ip[i]<0 then
     begin
      u[i]:=q[i];for j:=1 to iw do u[i]:=u[i]-p[i,j]*f[pt[i,j]];
     end;
    v[i]:=u[i];
   end;
  uu:=0;for i:=1 to n do uu:=uu+u[i]*u[i];
  while (it<2*n) and (uu>ee) do
   begin
    for i:=1 to n do
     begin
      w[i]:=0;iw:=pt[i,zz];
      for j:=1 to iw do w[i]:=w[i]+p[i,j]*v[pt[i,j]];
     end;
    vw:=0;for i:=1 to n do vw:=vw+v[i]*w[i];
    aa:=uu/vw;for i:=1 to n do if ip[i]<0 then
     begin
      f[i]:=f[i]+aa*v[i];u[i]:=u[i]-aa*w[i];
     end;
    ww:=0;for i:=1 to n do ww:=ww+u[i]*u[i];
    bb:=ww/uu;for i:=1 to n do v[i]:=u[i]+bb*v[i];
    uu:=ww;it:=it+1;
   end;
  for i:=1 to n do
   begin
    q[i]:=0;for j:=1 to pt[i,zz] do q[i]:=q[i]+p[i,j]*f[pt[i,j]];
   end;
 end;
procedure show;
 var
  xa,ya,xb,yb,dx,dy,sx,sy,xx,yy,x2,y2:real;
  i,j,k,l,ll,ia,ib,ja,jb,jj:integer;kk:longint;a:char;
 begin
  clrscr;
  xa:=x[1];xb:=xa;ya:=y[1];yb:=ya;for i:=1 to n do
   begin
    if (x[i]<xa) then xa:=x[i];if (x[i]>xb) then xb:=x[i];
    if (y[i]<ya) then ya:=y[i];if (y[i]>yb) then yb:=y[i];
   end;
  dx:=xb-xa;dy:=yb-ya;sx:=maxx/dx;sy:=(yasp/xasp)*maxy/dy;
  if sy<sx then sx:=sy;sy:=xasp*sx/yasp;
  initgraph(graphdriver,graphmode,'');setlinestyle(1,0,1);
  for j:=1 to m do
   begin
    for l:=1 to 3 do
     begin
      ll:=l+1;if ll>3 then ll:=1;
      ia:=round(sx*(x[np[j,l]]-xa));
      ib:=round(sx*(x[np[j,ll]]-xa));
      ja:=maxy-round(sy*(y[np[j,l]]-ya));
      jb:=maxy-round(sy*(y[np[j,ll]]-ya));
      line(ia,ja,ib,jb);
     end;
   end;
  setlinestyle(0,0,1);kk:=0;while (kk<ns) do
   begin
    for i:=1 to mp do if (sp[i]>0) then
     begin
      xx:=xp[i];yy:=yp[i];locate(xx,yy,lp[i],jj);
      if (jj=0) then sp[i]:=-1 else
       begin
        x2:=xx+step*vx[jj];y2:=yy+step*vy[jj];
        ia:=round(sx*(xx-xa));ib:=round(sx*(x2-xa));
        ja:=maxy-round(sy*(yy-ya));jb:=maxy-round(sy*(y2-ya));
        line(ia,ja,ib,jb);xp[i]:=x2;yp[i]:=y2;lp[i]:=jj;
       end;
     end;
    kk:=kk+1;if (keypressed) then kk:=ns;
   end;
  a:=readkey;closegraph;
 end;
begin
 graphinitialize;
 input;
 pointer;
 matrix;
 solve;
 velocities;
 show;
end.
