program flux;
uses crt,graph;
const
 ww=20;ff=100;
var
 maxx,maxy,graphdriver,graphmode,errorcode:integer;xasp,yasp:word;
 xw,yw,qw:array[1..ww] of real;
 xf,yf:array[1..ff] of real;sf:array[1..ff] of integer;
 nw,nf:longint;step,pi,por,hh,dx,dy,vxa,rm:real;data:text;
procedure title;
 begin
  clrscr;gotoxy(36,1);textbackground(7);textcolor(0);write(' FLUX ');
  textbackground(0);textcolor(7);writeln;writeln;
 end;
procedure graphinitialize;
 begin
  graphdriver:=detect;initgraph(graphdriver,graphmode,'');
  errorcode:=graphresult;
  if (errorcode<>grok) then
   begin
    writeln('Error in graphics :',grapherrormsg(errorcode));
    writeln;writeln('Program interrupted.');halt(1);
   end;
  setcolor(7);setbkcolor(0);setlinestyle(0,0,1);
  setfillstyle(11,7);maxx:=getmaxx;maxy:=getmaxy;
  getaspectratio(xasp,yasp);closegraph;
 end;
procedure input;
 var
  i,j:integer;name:string;
 begin
  title;pi:=3.1415926;
  writeln('This is a program for the analysis of 2-D transport by');
  writeln('groundwater flow for wells in an infinite strip.');writeln;
  write('Name of input datafile ............ ');readln(name);
  assign(data,name);reset(data);
  readln(data,dx,dy,vxa,step,por,hh,rm,nw,nf);
  for i:=1 to nw do readln(data,xw[i],yw[i],qw[i]);
  for j:=1 to nf do begin readln(data,xf[j],yf[j]);sf[j]:=1;end;
  close(data);title;
 end;
procedure velocities(x,y:real;var vx,vy:real);
 var
  i,k,kk,ll:integer;a,b,c,d,ea,eb,ch,sh,cb,sb,cc,sc:real;
 begin
  vx:=vxa;vy:=0;for i:=1 to nw do
   begin
    d:=qw[i]/(4*hh*por*dy);
    a:=pi*(x-xw[i])/dy;b:=pi*(y-yw[i])/dy;c:=pi*(y+yw[i])/dy;
    ea:=exp(a);eb:=1/ea;ch:=(ea+eb)/2;sh:=(ea-eb)/2;
    cb:=cos(b);sb:=sin(b);cc:=cos(c);sc:=sin(c);
    vx:=vx+d*(sh/(ch-cb)+sh/(ch-cc));
    vy:=vy+d*(sb/(ch-cb)+sc/(ch-cc));
   end;
 end;
procedure show;
 var
  xa,ya,r,sx,sy,x1,y1,x2,y2,vx,vy:real;
  i,j,kk,ia,ib,ja,jb:integer;a:char;
 begin
  clrscr;sx:=maxx/dx;sy:=(yasp/xasp)*maxy/dy;if sy<sx then sx:=sy;
  sy:=xasp*sx/yasp;initgraph(graphdriver,graphmode,'');
  kk:=0;while (kk=0) do
   begin
    for i:=1 to nf do if (sf[i]>0) then
     begin
      x1:=xf[i];y1:=yf[i];velocities(x1,y1,vx,vy);
      x2:=x1+vx*step/2;y2:=y1+vy*step/2;velocities(x2,y2,vx,vy);
      x2:=x1+vx*step;y2:=y1+vy*step;
      for j:=1 to nw do
       begin
        xa:=x1-xw[j];ya:=y1-yw[j];r:=sqrt(xa*xa+ya*ya);
        if (r<rm) then begin x2:=xw[j];y2:=yw[j];sf[i]:=-1;end;
       end;
      ia:=round(sx*x1);ib:=round(sx*x2);
      ja:=maxy-round(sy*y1);jb:=maxy-round(sy*y2);
      line(ia,ja,ib,jb);
      xf[i]:=x2;yf[i]:=y2;if ((x2<0) or (x2>dx)) then sf[i]:=-1;
     end;
    if (keypressed) then kk:=1;
   end;
  a:=readkey;closegraph;
 end;
begin
 graphinitialize;
 input;
 show;
end.
