program llp;
uses crt;
const
 nn=100;zz=4;ni=100;
var
 len,wid,wht,act,pas,neu,coh,stk,ei,ft,dz,cp,fa,ma:real;
 step,n,steps,ll,lp,nerr,mp,mq,plast,it:integer;
 z,s,d,f,u,q,ul,ur,m,ff:array[0..nn] of real;
 as,ps,sl,pa,pp,pn:array[1..nn] of real;
 p:array[0..nn,1..zz,1..2,1..2] of real;
 pt:array[0..nn,1..zz] of integer;
 g:array[1..2,1..2] of real;
 np,nq:array[0..nn] of integer;
procedure title;
 begin
  clrscr;gotoxy(38,1);textbackground(7);textcolor(0);write(' LLP ');
  textbackground(0);textcolor(7);writeln;writeln;
 end;
procedure next;
 var
  a:char;
 begin
  gotoxy(25,25);textbackground(7);textcolor(0);
  write(' Touch any key to continue ');write(chr(8));
  a:=readkey;textbackground(0);textcolor(7)
 end;
procedure input;
 var
  i:integer;
 begin
  title;
  write('This is a program for the analysis of a laterally loaded');
  writeln(' pile.');writeln;
  write('Length of the pile (m) ......... ');readln(len);
  write('Width of the pile (m) .......... ');readln(wid);
  write('Unit weight of soil (kN/m3) .... ');readln(wht);
  write('Active pressure coefficient .... ');readln(act);
  write('Passive pressure coefficient ... ');readln(pas);
  write('Neutral pressure coefficient ... ');readln(neu);
  write('Cohesion (kN/m2) ............... ');readln(coh);
  write('Total stroke (m) ............... ');readln(stk);
  write('Stiffness EI (kNm2) ............ ');readln(ei);
  write('Number of elements (max. 100) .. ');readln(n);
  write('Number of loading steps ........ ');readln(steps);
  if n<10 then n:=10;if n>nn then n:=nn;
  if act>1 then act:=1;if pas<1 then pas:=1;
  if neu<act then neu:=act;if neu>pas then neu:=pas;
  ft:=0;dz:=len/n;z[0]:=0;
  for i:=1 to n do begin z[i]:=z[i-1]+dz;d[i]:=dz;end;
  for i:=0 to n do
   begin
    u[i]:=0.0;m[i]:=0.0;ul[i]:=0.0;ur[i]:=0.0;
   end;
 end;
procedure zeros;
 var
  i:integer;
 begin
  for i:=1 to n do begin np[i]:=0;nq[i]:=0;end;
 end;
procedure constants;
 var
  i:integer;sz,e:real;
 begin
  for i:=1 to n do
   begin
    e:=0.000001;sz:=wht*wid*(z[i]-d[i]/2);
    pa[i]:=act*sz-2*coh*sqrt(act);if pa[i]<0 then pa[i]:=0;
    pn[i]:=neu*sz;pp[i]:=pas*sz+2*coh*sqrt(pas);
    if pp[i]<pa[i]+e then pp[i]:=pa[i]+e;
    as[i]:=(pn[i]-pa[i])*stk/(pp[i]-pa[i]);
    ps[i]:=(pp[i]-pn[i])*stk/(pp[i]-pa[i]);
    sl[i]:=(pp[i]-pa[i])/stk;
   end;
 end;
procedure springs;
 var
  i,nr:integer;um,sp,eps,sx:real;
 begin
  nerr:=0;plast:=0;eps:=0.000001;
  for i:=1 to n do
   begin
    um:=(u[i]+u[i-1])/2;if um-ul[i]>as[i]+eps then
     begin
      sx:=pa[i];sp:=0;nr:=1;plast:=plast+1;
     end
    else if um-ul[i]<-ps[i]-eps then
     begin
      sx:=pp[i];sp:=0;nr:=-1;plast:=plast+1;
     end
    else
     begin
      sp:=sl[i];sx:=pn[i]+sp*ul[i];nr:=0;
     end;
    f[i]:=sx*d[i];s[i]:=sp*d[i];
    if np[i]<>nr then
     begin
      np[i]:=nr;nerr:=nerr+1;
     end;
    if um-ur[i]<-as[i]-eps then
     begin
      sx:=pa[i];sp:=0;nr:=1;plast:=plast+1;
     end
    else if um-ur[i]>ps[i]+eps then
     begin
      sx:=pp[i];sp:=0;nr:=-1;plast:=plast+1;
     end
    else
     begin
      sp:=sl[i];sx:=pn[i]-sp*ur[i];nr:=0;
     end;
    f[i]:=f[i]-sx*d[i];s[i]:=s[i]+sp*d[i];
    if nq[i]<>nr then
     begin
      nq[i]:=nr;nerr:=nerr+1;
     end;
   end;
 end;
procedure matrix;
 var
  i,j,h,k,l:integer;a1,a2,b1,b2,c1:real;
 begin
  h:=zz;
  for i:=0 to n do for j:=1 to zz do
   begin
    pt[i,j]:=0;
    for k:=1 to 2 do for l:=1 to 2 do p[i,j,k,l]:=0;
   end;
  for i:=1 to n-1 do
   begin
    pt[i,1]:=i;pt[i,2]:=i-1;pt[i,3]:=i+1;pt[i,zz]:=3;
   end;
  pt[0,1]:=0;pt[0,2]:=1;pt[0,zz]:=2;
  pt[n,1]:=n;pt[n,2]:=n-1;pt[n,zz]:=2;
  for i:=1 to n-1 do
   begin
    a1:=1.0/d[i+1];a2:=1.0/d[i];
    p[i,1,1,1]:=-a1-a2;p[i,2,1,1]:=a2;p[i,3,1,1]:=a1;
    p[i,1,1,2]:=-(s[i]+s[i+1])/4.0;p[i,2,1,2]:=-s[i]/4.0;
    p[i,3,1,2]:=-s[i+1]/4.0;
    p[i,zz,1,1]:=-(f[i]+f[i+1])/2.0;
    p[i,1,2,2]:=-a1-a2;p[i,2,2,2]:=a2;p[i,3,2,2]:=a1;
    p[i,1,2,1]:=(d[i]+d[i+1])/(4.0*ei);
    p[i,2,2,1]:=d[i]/(4.0*ei);p[i,3,2,1]:=d[i+1]/(4.0*ei);
   end;
  p[0,1,1,1]:=1.0;p[0,zz,1,1]:=ma;
  p[0,1,2,2]:=s[1]/4.0;p[0,2,2,2]:=s[1]/4.0;
  p[0,1,2,1]:=1.0/d[1];p[0,2,2,1]:=-1.0/d[1];
  p[0,zz,2,2]:=f[1]/2.0+fa;p[n,1,1,1]:=1.0;
  p[n,1,2,2]:=s[n]/4.0;p[n,2,2,2]:=s[n]/4.0;
  p[n,1,2,1]:=1.0/d[n];p[n,2,2,1]:=-1.0/d[n];
  p[n,zz,2,2]:=f[n]/2.0;
 end;
procedure solve;
 var
  i,j,h,k,l,ii,ij,ik,jj,jk,jl,jv,kc,kv,lv:integer;
  cc,aa:real;
 begin
  h:=zz;
  for i:=n downto 0 do
   begin
    kc:=pt[i,zz];for kv:=1 to 2 do
     begin
      if p[i,1,kv,kv]=0.0 then
       begin
        writeln('Error : no equilibrium possible');halt;
       end;
      cc:=1.0/p[i,1,kv,kv];
      for ii:=1 to kc do for lv:=1 to 2 do
       begin
        p[i,ii,kv,lv]:=cc*p[i,ii,kv,lv];
       end;
      p[i,zz,kv,kv]:=cc*p[i,zz,kv,kv];
      for lv:=1 to 2 do if (lv<>kv) then
       begin
        cc:=p[i,1,lv,kv];
        for ii:=1 to kc do for ij:=1 to 2 do
         begin
          p[i,ii,lv,ij]:=p[i,ii,lv,ij]-cc*p[i,ii,kv,ij];
         end;
        p[i,zz,lv,lv]:=p[i,zz,lv,lv]-cc*p[i,zz,kv,kv];
       end;
     end;
    if kc>1 then
     begin
      for j:=2 to kc do
       begin
        jj:=pt[i,j];l:=pt[jj,zz];jk:=l;
        for jl:=2 to l do begin if pt[jj,jl]=i then jk:=jl;end;
        for kv:=1 to 2 do for lv:=1 to 2 do g[kv,lv]:=p[jj,jk,kv,lv];
        pt[jj,jk]:=pt[jj,l];pt[jj,l]:=0;
        for kv:=1 to 2 do for lv:=1 to 2 do
         begin
          p[jj,jk,kv,lv]:=p[jj,l,kv,lv];p[jj,l,kv,lv]:=0;
          p[jj,zz,lv,lv]:=p[jj,zz,lv,lv]-g[lv,kv]*p[i,zz,kv,kv];
         end;
        l:=l-1;pt[jj,zz]:=l;
        for ii:=2 to kc do
         begin
          ij:=0;for ik:=1 to l do
           begin
            if pt[jj,ik]=pt[i,ii] then ij:=ik;
           end;
          if ij=0 then
           begin
            l:=l+1;ij:=l;pt[jj,zz]:=l;pt[jj,ij]:=pt[i,ii];
           end;
          for kv:=1 to 2 do for lv:=1 to 2 do for jv:=1 to 2 do
            p[jj,ij,kv,lv]:=p[jj,ij,kv,lv]-g[kv,jv]*p[i,ii,jv,lv];
         end;
       end;
     end;
   end;
  for j:=0 to n do
   begin
    l:=pt[j,zz];if l>1 then
     begin
      for k:=2 to l do
       begin
        jj:=pt[j,k];
        for kv:=1 to 2 do for lv:=1 to 2 do
          p[j,zz,kv,kv]:=p[j,zz,kv,kv]-p[j,k,kv,lv]*p[jj,zz,lv,lv];
       end;
     end;
   end;
  for i:=0 to n do
   begin
    m[i]:=p[i,zz,1,1];u[i]:=p[i,zz,2,2];
   end;
  q[0]:=-fa;ff[0]:=0;for i:=1 to n do
   begin
    aa:=(m[i]-m[i-1])/d[i];
    q[i]:=-q[i-1]+2*aa;ff[i]:=(q[i-1]-q[i])/d[i];
   end;
 end;
procedure update;
 var
  i:integer;aa:real;
 begin
  for i:=1 to n do
   begin
    aa:=(u[i]+u[i-1])/2-ul[i];
    if aa>=as[i] then ul[i]:=(u[i]+u[i-1])/2-as[i];
    if aa<=-ps[i] then ul[i]:=(u[i]+u[i-1])/2+ps[i];
    aa:=(u[i]+u[i-1])/2-ur[i];
    if aa<=-as[i] then ur[i]:=(u[i]+u[i-1])/2+as[i];
    if aa>=ps[i] then ur[i]:=(u[i]+u[i-1])/2-ps[i];
   end;
 end;
begin
 input;constants;zeros;
 for step:=1 to steps do
  begin
   title;it:=0;writeln('Loading step ',step);writeln;
   write('Force at the top (kN) .............. ');readln(fa);writeln;
   write('Moment at the top (kNm) ............ ');readln(ma);writeln;
   springs;
   repeat
    matrix;solve;springs;
    if plast=2*n then begin writeln('Pile failed');nerr:=0;end;
    it:=it+1;if it=ni then
     begin
      writeln('Warning : no convergence ');writeln;nerr:=0;
     end;
   until nerr=0;
   if plast<2*n then
    begin
     writeln('Displacement at the top (m) ........ ',u[0]:8:6);
     writeln;
     writeln('Number of plastic springs .......... ',plast);
     next;update;
    end
   else step:=steps;
  end;
 title;
end.
