program nsf;
uses crt;
const
 nn=300;mm=250;zz=10;tt=100;
var
 x,y,f,f0,q,qt,u,v,w:array[1..nn] of real;
 ip:array[1..nn] of integer;
 tr,st,pp:array[1..mm] of real;
 np:array[1..mm,1..4] of integer;
 p,r:array[1..nn,1..zz-1] of real;
 pt:array[1..nn,1..zz] of integer;
 xj,yj:array[1..4] of real;
 b,c,d:array[1..3] of real;
 t:array[0..tt] of real;
 ks:array[1..4,1..3] of integer;
 n,m,nt,i,out:integer;eps,step:real;data:text;
procedure title;
 begin
  clrscr;gotoxy(37,1);textbackground(7);textcolor(0);write(' NSF ');
  textbackground(0);textcolor(7);writeln;writeln;
 end;
procedure input;
 var
  i,j,k:integer;c2,tc:real;name:string;
 begin
  title;
  writeln('This is a program for the analysis of non-steady plane');
  writeln('groundwater flow by the finite element method.');writeln;
  write('Name of input datafile ............ ');readln(name);
  assign(data,name);reset(data);readln(data,n,m,nt,eps,out);
  for i:=1 to n do readln(data,x[i],y[i],ip[i],f0[i],q[i]);
  for j:=1 to m do
    readln(data,np[j,1],np[j,2],np[j,3],np[j,4],tr[j],st[j],pp[j]);
  t[0]:=0.0;for k:=1 to nt do  readln(data,t[k]);
  close(data);title;for i:=1 to n do f[i]:=f0[i];
  for i:=1 to 4 do for j:=1 to 3 do
   begin
    k:=i+j-1;if k>4 then k:=k-4;ks[i,j]:=k;
   end;
 end;
procedure pointer;
 var
  i,j,k,l,kk,ll,ia,ii,kb:integer;
 begin
  title;writeln('Generation of pointer matrix');writeln;
  for i:=1 to n do for j:=1 to zz do pt[i,j]:=0;
  for i:=1 to n do begin pt[i,1]:=i;pt[i,zz]:=1;end;
  for j:=1 to m do
   begin
    for k:=1 to 4 do
     begin
      kk:=np[j,k];for l:=1 to 4 do
       begin
        ll:=np[j,l];ia:=0;
        for ii:=1 to pt[kk,zz] do if pt[kk,ii]=ll then ia:=1;
        if ia=0 then
         begin
          kb:=pt[kk,zz]+1;
          if kb=zz then
           begin
            writeln('Pointer width too small.');writeln;halt;
           end;
          pt[kk,zz]:=kb;pt[kk,kb]:=ll;
         end;
       end;
     end;
   end;
 end;
procedure matrix;
 var
  i,j,k,l,kv,kw,ii,kk,ll:integer;
  zx,zy,dd,ee,dp,dr,xx,xy,yy,aa:real;
 begin
  ee:=0.000001;
  for i:=1 to n do
   begin
    qt[i]:=q[i];f0[i]:=f[i];
    for j:=1 to zz-1 do begin p[i,j]:=0;r[i,j]:=0;end;
   end;
  for j:=1 to m do
   begin
    for kw:=1 to 4 do
     begin
      zx:=0;zy:=0;for i:=1 to 3 do
       begin
        k:=np[j,ks[kw,i]];xj[i]:=x[k];yj[i]:=y[k];
        zx:=zx+x[k];zy:=zy+y[k];
       end;
      zx:=zx/3;zy:=zy/3;for i:=1 to 3 do
       begin
        xj[i]:=xj[i]-zx;yj[i]:=yj[i]-zy;
       end;
      b[1]:=yj[2]-yj[3];b[2]:=yj[3]-yj[1];b[3]:=yj[1]-yj[2];
      c[1]:=xj[3]-xj[2];c[2]:=xj[1]-xj[3];c[3]:=xj[2]-xj[1];
      d[1]:=xj[2]*yj[3]-xj[3]*yj[2];d[2]:=xj[3]*yj[1]-xj[1]*yj[3];
      d[3]:=xj[1]*yj[2]-xj[2]*yj[1];dd:=abs(d[1]+d[2]+d[3]);
      if dd>ee then
       begin
        dp:=tr[j]/(4*dd);dr:=st[j]/(4*step*(1-eps)*dd);
        xx:=(xj[1]*xj[1]+xj[2]*xj[2]+xj[3]*xj[3])/12;
        xy:=(xj[1]*yj[1]+xj[2]*yj[2]+xj[3]*yj[3])/12;
        yy:=(yj[1]*yj[1]+yj[2]*yj[2]+yj[3]*yj[3])/12;
        for k:=1 to 3 do
         begin
          kk:=np[j,ks[kw,k]];ii:=pt[kk,zz];
          for ll:=1 to ii do
           begin
            for l:=1 to 3 do
             begin
              kv:=ks[kw,l];if np[j,kv]=pt[kk,ll] then
               begin
                p[kk,ll]:=p[kk,ll]+dp*(b[k]*b[l]+c[k]*c[l]);
                aa:=xx*b[k]*b[l]+xy*(b[k]*c[l]+b[l]*c[k]);
                aa:=aa+yy*c[k]*c[l]+d[k]*d[l];
                r[kk,ll]:=r[kk,ll]+dr*aa;
               end;
             end;
           end;
         end;
       end;
      for i:=1 to 3 do
       begin
        k:=np[j,ks[kw,i]];qt[k]:=qt[k]+dd*pp[j]/12;
       end;
     end;
   end;
 end;
procedure solvecg;
 var
  it,i,j,l,iw:integer;
  ee,uu,cc,vw,ww,aa,bb:real;
 begin
  ee:=0.000001;ee:=ee*ee;it:=1;
  for i:=1 to n do
   begin
    iw:=pt[i,zz];u[i]:=0;if ip[i]<0 then
     begin
      u[i]:=qt[i];for j:=1 to iw do
       begin
        cc:=r[i,j];l:=pt[i,j];
        u[i]:=u[i]-(p[i,j]+cc)*f[l]+cc*f0[l];
       end;
     end;
    v[i]:=u[i];
   end;
  uu:=0;for i:=1 to n do uu:=uu+u[i]*u[i];
  while (it<n) and (uu>ee) do
   begin
    for i:=1 to n do
     begin
      w[i]:=0;iw:=pt[i,zz];for j:=1 to iw do
       begin
        w[i]:=w[i]+(p[i,j]+r[i,j])*v[pt[i,j]];
       end;
     end;
    vw:=0;for i:=1 to n do vw:=vw+v[i]*w[i];
    aa:=uu/vw;for i:=1 to n do if ip[i]<0 then
     begin
      f[i]:=f[i]+aa*v[i];u[i]:=u[i]-aa*w[i];
     end;
    ww:=0;for i:=1 to n do ww:=ww+u[i]*u[i];
    bb:=ww/uu;for i:=1 to n do v[i]:=u[i]+bb*v[i];
    uu:=ww;it:=it+1;
   end;
  for i:=1 to n do f[i]:=f0[i]+(f[i]-f0[i])/(1-eps);
 end;
begin
 input;
 pointer;
 title;
 writeln('Node ',out,', x = ',x[out]:9:3,', y = ',y[out]:9:3,' :');
 writeln;writeln('t = ',t[0]:9:3,', f = ',f0[out]:9:3);
 for i:=1 to nt do
  begin
   step:=t[i]-t[i-1];
   matrix;
   solvecg;
   writeln('t = ',t[i]:9:3,', f = ',f[out]:9:3);
  end;
end.
