program plug;
uses crt,graph;
const
 nn=400;zz=4;
var
 maxx,maxy,graphdriver,graphmode,errorcode:integer;xasp,yasp:word;
 length,diam,elast,stiff,gamma,circum,area,fric,quake:real;
 dz,tz,wmax:real;step,n,steps,plast:integer;
 z,w,wz,f,fz,d,s,t,st,sz,v,ea,ss,ta,tb,qq:array[0..nn] of real;
 p:array[0..nn,1..zz] of real;pt:array[0..nn,1..zz] of integer;
 np:array[0..nn] of integer;
procedure title;
 begin
  clrscr;gotoxy(37,1);textbackground(7);textcolor(0);write(' PLUG ');
  textbackground(0);textcolor(7);writeln;writeln;
 end;
procedure next;
 var
  a:char;
 begin
  gotoxy(25,25);textbackground(7);textcolor(0);
  write(' Touch any key to continue ');write(chr(8));
  a:=readkey;textbackground(0);textcolor(7);
 end;
procedure input;
 var
  i:integer;pi,zm:real;
 begin
  title;pi:=3.1415926;writeln('Input data :');writeln;
  write('Length of the plug (m) ......... ');readln(length);
  write('Diameter (m) ................... ');readln(diam);
  write('Stiffness coefficient .......... ');readln(stiff);
  write('Volumetric weight (kN/m3) ...... ');readln(gamma);
  write('Friction coefficient ........... ');readln(fric);
  write('Quake (m) ...................... ');readln(quake);
  write('Displacement of pile (m) ....... ');readln(wmax);
  write('Number of elements (max. ',nn,') .. ');readln(n);
  write('Number of loading steps ........ ');readln(steps);
  if n<10 then n:=10;if n>nn then n:=nn;circum:=pi*diam;
  area:=circum*diam/4;stiff:=stiff*area;dz:=length/n;plast:=0;z[0]:=0;
  for i:=1 to n do
   begin
    d[i]:=dz;z[i]:=z[i-1]+d[i];qq[i]:=quake;zm:=0.5*(z[i-1]+z[i]);
    ea[i]:=stiff*gamma*zm;ta[i]:=fric*circum*d[i]*gamma*zm;
   end;
  for i:=0 to n do
   begin
    v[i]:=wmax/steps;np[i]:=0;f[i]:=0;fz[i]:=0;sz[i]:=0;wz[i]:=0;
   end;
 end;
procedure initial;
 var
  i:integer;ff,zm,ss:real;
 begin
  for i:=1 to n do
   begin
    zm:=0.5*(z[i-1]+z[i]);ff:=0.5*(fz[i-1]+fz[i]);
    ss:=ff/area+gamma*zm;ta[i]:=fric*circum*d[i]*ss;
    ea[i]:=stiff*ss;s[i]:=ta[i]/qq[i];t[i]:=s[i]*v[i];
    if np[i]>0 then t[i]:=0;
   end;
 end;
procedure matrix;
 var
  i,j:integer;a1,a2,b1,b2,c1:real;
 begin
  for i:=0 to n do for j:=1 to zz do
   begin
    pt[i,j]:=0;p[i,j]:=0;
   end;
  for i:=1 to n-1 do
   begin
    pt[i,1]:=i;pt[i,2]:=i-1;pt[i,3]:=i+1;pt[i,zz]:=3;
   end;
  pt[0,1]:=0;pt[0,2]:=1;pt[0,zz]:=2;pt[n,1]:=n;pt[n,zz]:=2;
  for i:=1 to n-1 do
   begin
    a1:=2*ea[i]/d[i];a2:=2*ea[i+1]/d[i+1];b1:=s[i]/2;b2:=s[i+1]/2;
    p[i,1]:=a1+a2+b1+b2;p[i,2]:=-a1+b1;p[i,3]:=-a2+b2;
    p[i,zz]:=t[i]+t[i+1];
   end;
  a1:=2*ea[1]/d[1];b1:=s[1]/2;
  p[0,1]:=a1+b1;p[0,2]:=-a1+b1;p[0,zz]:=t[1];
  p[n,1]:=1;p[n,2]:=0;p[n-1,3]:=0;p[n,zz]:=0;
 end;
procedure solve;
 var
  i,j,k,l,kc,jj,jk,jl,ii,ij,ik:integer;c:real;a:char;
 begin
  for i:=0 to n do
   begin
    kc:=pt[i,zz];if kc>1 then
     begin
      for j:=2 to kc do
       begin
        if p[i,1]=0.0 then
         begin
          writeln('Error : no equilibrium possible');halt;
         end;
        c:=p[i,j]/p[i,1];jj:=pt[i,j];
        p[jj,zz]:=p[jj,zz]-c*p[i,zz];l:=pt[jj,zz];
        for jl:=2 to l do begin if pt[jj,jl]=i then jk:=jl;end;
        pt[jj,jk]:=pt[jj,l];pt[jj,l]:=0;
        p[jj,jk]:=p[jj,l];p[jj,l]:=0;l:=l-1;pt[jj,zz]:=l;
        for ii:=2 to kc do
         begin
          ij:=0;for ik:=1 to l do if pt[jj,ik]=pt[i,ii] then ij:=ik;
          if ij=0 then
           begin
            l:=l+1;ij:=l;pt[jj,zz]:=l;pt[jj,ij]:=pt[i,ii];
           end;
          p[jj,ij]:=p[jj,ij]-c*p[i,ii];
         end;
       end;
     end;
    if p[i,1]=0.0 then
     begin
      writeln('Error : no equilibrium possible');halt;
     end;
    c:=1/p[i,1];for j:=1 to kc do p[i,j]:=c*p[i,j];p[i,zz]:=c*p[i,zz];
   end;
  for i:=0 to n do
   begin
    j:=n-i;l:=pt[j,zz];if l>1 then
      for k:=2 to l do p[j,zz]:=p[j,zz]-p[j,k]*p[pt[j,k],zz];
   end;
  f[0]:=0;
  for i:=0 to n do
   begin
    w[i]:=p[i,zz];wz[i]:=wz[i]+w[i];
   end;
  for i:=1 to n do f[i]:=-2*ea[i]*(w[i]-w[i-1])/d[i]-f[i-1];
  st[0]:=0;for i:=1 to n do st[i]:=(f[i]-f[i-1])/(circum*d[i]);
  for i:=1 to n do
   begin
    fz[i]:=fz[i]+f[i];sz[i]:=sz[i]+st[i];
   end;
 end;
procedure checksprings;
 var
  i:integer;ff,ss,zm,eps:real;
 begin
  plast:=0;
  for i:=1 to n do
   begin
    ff:=0.5*(fz[i-1]+fz[i]);zm:=0.5*(z[i-1]+z[i]);
    ss:=ff/area+gamma*zm;if (sz[i]>fric*ss) then np[i]:=1;
    if np[i]>0 then plast:=plast+1;
   end;
 end;
procedure output;
 var
  i,k:integer;tt:real;
 begin
  title;k:=0;
  write('  z        w                 s              t');
  writeln('             tmax');
  for i:=0 to n do
   begin
    write(z[i]:6:3,wz[i]:12:6,fz[i]/area+gamma*z[i]:15:3);
    if (i>0) then
     begin
      tt:=0.25*gamma*diam*(exp(2*fric*(z[i-1]+z[i])/diam)-1);
      write(sz[i]:15:3,tt:15:3);
     end;
    writeln;k:=k+1;
    if (k>20) then
     begin
      next;k:=1;title;
      write('  z        w                 s              t');
      writeln('             tmax');
     end;
   end;
 end;
procedure graphinitialize;
 begin
  graphdriver:=detect;initgraph(graphdriver,graphmode,'');
  errorcode:=graphresult;
  if (errorcode<>grok) then
   begin
    writeln('Error in graphics :',grapherrormsg(errorcode));
    writeln;writeln('Program interrupted.');halt(1);
   end;
  setcolor(7);setbkcolor(0);setlinestyle(0,0,1);
  setfillstyle(11,7);maxx:=getmaxx;maxy:=getmaxy;
  getaspectratio(xasp,yasp);closegraph;
 end;
procedure showt;
 var
  x,x1,x3,y,y1,y3,xa,xb,ya,yb,i:integer;
  tm,sx,sy,tt,zz:real;a:char;
 begin
  tm:=0.3*gamma*diam*(exp(4*fric*length/diam)-1);
  if tm>0 then
   begin
    initgraph(graphdriver,graphmode,'');
    x1:=round(0.1*maxx);x3:=maxx-x1;
    y1:=round(0.9*maxy);y3:=maxy-y1;
    line(x1,y3,x3,y3);line(x1,y1+20,x1,y3);
    line(x3,y3,x3-8,y3-2);line(x3,y3,x3-8,y3+2);
    line(x1,y1+20,x1-2,y1+12);line(x1,y1+20,x1+2,y1+12);
    outtextxy(20,10,'Shear stress');
    outtextxy(x3-2,y3+8,'t');outtextxy(x1+6,y1+16,'z');
    sx:=0.8*maxx/tm;sy:=0.8*maxy/z[n];zz:=0.5*(z[0]+z[1]);
    xa:=x1+round(sx*sz[1]);ya:=y3+round(sy*zz);
    for i:=2 to n do
     begin
      zz:=0.5*(z[i-1]+z[i]);
      xb:=x1+round(sx*sz[i]);yb:=y3+round(sy*zz);
      line(xa,ya,xb,yb);xa:=xb;ya:=yb;
     end;
    zz:=0.5*(z[0]+z[1]);tt:=0.25*gamma*diam*(exp(4*fric*zz/diam)-1);
    for i:=1 to n do
     begin
      zz:=0.5*(z[i-1]+z[i]);tt:=0.25*gamma*diam*(exp(4*fric*zz/diam)-1);
      xa:=x1+round(sx*tt);ya:=y3+round(sy*zz);line(xa,ya,xa,ya);
     end;
    a:=readkey;closegraph;
   end
 end;
begin
 graphinitialize;input;
 for step:=1 to steps do
  begin
   title;writeln('Loading step ....................... ',step:8);writeln;
   writeln('Displacement of pile (m) ........... ',step*v[0]:15:6);writeln;
   writeln('Displacement of plug (m) ........... ',wz[0]:15:6);writeln;
   writeln('Force at the bottom (kN) ........... ',fz[n]:15:6);writeln;
   writeln('Plastic springs .................... ',plast:8);
   initial;matrix;solve;checksprings;
  end;
 output;showt;clrscr;
end.
